from random import* #module fonction aleatoire
import turtle as t #module de dessin
###FONCTION APPELEE PAR LE PROGRAMME###

"""dessine les branche de l'arbre"""
def arbre(f_lenght, min_lenghta=2):
  t.width(2)
  t.forward(f_lenght)
  if f_lenght > min_lenghta:
    t.left(45)
    arbre(0.6*f_lenght, min_lenghta)
    t.right(90)
    arbre(0.6*f_lenght, min_lenghta)
    t.left(45)
  t.back(f_lenght)

"""dessine les feuille de l'arbre puis appelle arbre()"""
def dessin_arbre(f_lenght, min_lenghta=10):
  t.width(1)
  t.up()
  t.goto(XO-7,YO+22)
  t.circle(7,-90)
  t.down()
  t.circle(7,-180)
  t.left(90)
  t.circle(7,-180)
  t.left(180)
  t.circle(7,-180)
  t.left(90)
  t.circle(7,-180)
  t.up()
  t.goto(XO,YO)
  t.left(90)
  t.down()
  arbre(f_lenght, min_lenghta=2)

"""dessine les petale d'une fleur"""
def petal(petal_length=2):
  t.right(135)
  t.circle(petal_length,90)
  t.left(-90)
  t.circle(- petal_length,-90)
  t.left(45)

"""dessine le pollen de la fleur puis appele petal()"""
def dessin_fleur(petal_length=4, pollen_length=2):
  t.up()
  t.goto(XO,YO - pollen_length)
  t.down()
  t.circle(pollen_length)
  for i in range(8):
    petal(petal_length)
    t.circle(pollen_length,45)
  t.circle(pollen_length, 22.5)
  for k in range(8):
    petal(petal_length)
    t.circle(pollen_length,45)

"""dessine un oiseaux"""
def dessin_oiseaux():
  t.up()
  t.goto(XO,YO)
  t.forward(5)
  t.left(90)
  t.forward(-10)
  t.right(22.5)
  t.down()
  t.circle(10,-180)
  t.goto(XO+5,YO-10)
  t.up()
  t.goto(XO-13.478,YO-2.346)
  t.down()
  t.circle(-2,-135)
  t.goto(XO-13.478,YO+1.346)
  t.right(150)
  t.circle(7.5,-90)
  t.left(180)
  t.forward(19)
  t.right(165)
  t.forward(5)
  t.goto(XO+15.5,YO-12.5)
  t.goto(XO+5,YO-10)
  t.up()
  t.goto(XO-8.5,YO+2.5)
  t.down()
  t.circle(1)
  t.up()
  t.goto(XO-11,YO-13.5)
  t.down()
  t.left(45)
  for z in range(3):
    t.circle(5,50)
    t.right(11.25)
    t.circle(5,-50)
    t.left(22.5)
  t.up()
  t.goto(XO-9,YO+2)
  t.down()
  t.circle(0.2)

"""cree les parametre de la tortue"""
t.width(1) #Mets la taille du tracer a un
t.speed('fastest') #Mets la vitesse du tracer au plus rapide

###DEBUT DU PROGRAME###
"""permet de dessiner le ciel"""
t.backward(200)
t.forward(400)
t.ht()

"""permet de dessiner le chemin"""
t.up() #Arrete le tracer
t.goto(0,-115) #Va au point (0;-115)
t.down() #Reprend le tracer
t.circle(30,-120) #
t.circle(-30,-90) #
t.circle(20,-95) #
t.goto(-40,0) #
t.left(180) # Dessine le chemin
t.circle(-18,-90) #
t.circle(40,-80) #
t.circle(-25,-90) #
t.goto(0,-115) #

"""dessine des arbre a des position alleatoire"""
XO = -200 #Position x de depart pour les arbre
for k in range(7): #Boucle pour cree sept arbre
  t.setheading(90) #Remet le cursseur (turtle) droit
  XO = XO + randint(40,60) #Position x de l'arbre
  YO = 0 #Position y de l'arbre
  t.setheading(90) #Remet le cursseur (turtle) droit
  dessin_arbre(15) #Dessin de l'arbre
  t.setheading(90) #Remet le cursseur (turtle) droit

"""dessine des fleur"""
t.width(1) #Mets la taille du tracer a un
for k in range(5): #Boucle pour cree cinq fleur
  XO = randint(-170,-110) #Position x de la fleur
  YO = randint(-70,-30) #Position y de la fleur
  dessin_fleur() #Dessin de la fleur
  t.setheading(0) #Remet le cursseur (turtle) droit
for k in range(3): #Boucle pour cree trois fleur
  XO = randint(40,170) #Position x de la fleur
  YO = randint(-70,-30) #Position y de la fleur
  dessin_fleur() #Dessin de la fleur
  t.setheading(0) #Remet le cursseur (turtle) droit

"""dessine des oiseaux"""
for k in range(2): #Boucle pour cree deux oiseaux
  XO = randint(10,40) #Position x de l'oiseau
  YO = randint(-70,-30) #Position y de l'oiseau
  dessin_oiseaux() #Dessine un oiseau
  t.setheading(0) #Remet le cursseur (turtle) droit
###FIN